program golden_ratio
! experiments with the golden ratio iterative relation
  implicit none
  integer, parameter :: rk = kind(1.0d0)
  real(rk) :: phi, phi_old
  real(rk) :: phi_start, tol
  integer :: i, max_iter
  
  open(11,FILE='goldenfile.in',STATUS='old')
  read(11,*) phi_start, tol, max_iter
  close(11)

  phi_old = phi_start
  do i=1,max_iter
    phi = 1.0d0/phi_old + 1.0d0
    if (abs(phi - phi_old) < tol) exit
    phi_old = phi
  end do

  open(12,FILE='golden.out')
  write(12,100) 'Start value:',phi_start
  write(12,100) 'Tolerance:',tol
  write(12,'(2(A," ",I11,"  "))') 'Ended at iteration:', i, 'of', max_iter
  write(12,100) 'Final value:',phi
  close(12)

100 format(A," ",F13.10)
end program golden_ratio
